{$V-,I-,R-,F+}
Unit TSRU;

(************************************************)
Interface
(************************************************)

Uses  DOS, CRT;

Const
  OldStackSS    : Word = 0;
  OldStackSP    : Word = 0;
  OurStackSeg   : Word = 0;
  OurStackSP    : Word = 0;

  StackSW       : Integer = -1;

  EndDos  : Word = 0;

(************************************************)

Const
  ScanCode  : Byte = 0;
  KeyMask   : Byte = 0;

(************************************************)

Var
  TimerVec,
  KbdVec,
  Old28Vec,
  OldCritVec:  Pointer;

  DosSeg   : Word;

  DOSBusy  : Word;

  OldDTASeg,
  OldDTAOfs,
  OurDtaSeg,
  OurDtaOfs : Word;

  SaveBreak : Byte;

  PopRtn : Pointer;

  TSR_Byte,
  TSR_VEC       : Byte;
  TSR_PSP       : Word;
  INT_PSP       : Word;
  PSPArray      : array[1..2] of word;
  PSP_Counter   : Byte;

Const
  TimerInt = $1C;
  KbdInt   = $09;
  Int28Int = $28;
  CritInt  = $24;

  PopFlag : Boolean = FALSE;
  Running : Boolean = FALSE;
  TSROFF  : Boolean = FALSE;

(************************************************)

Procedure CallOldInt(sub: Pointer);

Procedure PopSetup(pr: Pointer;
                   SC,KM : Byte);

Procedure BeginPop;

Procedure EndPop;

Procedure install_int;

Function TSRExit : Boolean;

Function DupCheck(Var S: String; rtn: Pointer) : Byte;

Procedure BeginInt;
InLine($FF/$06/stacksw/
       $75/$10/
       $8C/$16/OldStackSS/
       $89/$26/OldStackSP/
       $8E/$16/OurStackSeg/
       $8B/$26/OurStackSP);

Procedure EndInt;
InLine($FF/$0E/stacksw/
       $7D/$08/
       $8E/$16/OldStackSS/
       $8B/$26/OldStackSP);

Procedure CLI; InLine($FA);

Procedure STI; InLine($FB);

Procedure CallPop(sub: Pointer);

(************************************************)
Implementation
(************************************************)

Procedure NewCrit(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
  Interrupt;
Begin
ax := 0;
End;

(************************************************)

Procedure SaveStack;
Begin
OurStackSeg := sseg;
InLine($89/$26/OurStackSP);
End;

(************************************************)

Procedure CallPop(sub: Pointer);
Begin
InLine($FF/$5E/$06);
End;

(************************************************)

Procedure CallOldInt(sub: Pointer);
Begin
InLine($9C/$FF/$5E/$06);
End;

(************************************************)

Procedure New28(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
  Interrupt;
Begin
CLI;
BeginInt;
STI;

CallOldInt(Old28Vec);
If ( (PopFlag) AND (Mem[DosSeg:DOSBusy] <> 0) ) Then
  begin
  PopFlag := FALSE;
  CallPop(PopRtn);
  end;

CLI;
EndInt;
STI;
End;

(************************************************)

Procedure Clock(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
  Interrupt;
Begin
CLI;
BeginInt;
STI;

CallOldInt(TimerVec);

If (PopFlag AND (Mem[DosSeg:DOSBusy] = 0) ) Then
  begin
  Port[$20] := $20;
  PopFlag := FALSE;
  CallPop(PopRtn);
  end;

CLI;
EndInt;
STI;
End;

(************************************************)

Procedure KeyBoard(Flags,CS,IP,AX,BX,CX,DX,SI,DI,DS,ES,BP: Word);
  Interrupt;

label
  TSRdown,
  KeyExit;

Begin

CLI;
BeginInt;
STI;

If TSROFF Then
  GoTo TSRdown;

If (Port[$60] = ScanCode) Then
  begin
  If ( (Mem[0000:$0417] AND KeyMask) = KeyMask) Then
    begin
    TSR_Byte  := Port[$61];
    Port[$61] := TSR_Byte Or $80;
    Port[$61] := TSR_Byte;

    CLI;
    Port[$20] := $20;
    STI;

    If NOT Running Then
      PopFlag := TRUE;
    GoTo KeyExit;
    end;
  end;

TSRdown:

CallOldInt(KbdVec);

KeyExit:

CLI;
EndInt;
STI;
End;

(************************************************)

Procedure Install_int;
Begin
SetIntVec(TimerInt, @clock);
SetIntVec(KbdInt,   @KeyBoard);
SetIntVec(Int28Int, @New28);
If stacksw = -1 Then
  SetIntVec($1B, SaveInt1B);
End;

(************************************************)
{Release any memory allocated by this TSR program}
(************************************************)

Procedure rel_mem;
Var
  r : Registers;

Begin
While (Mem[EndDos:0] = $4D) Do
  begin
  If (MemW[EndDos:1] = TSR_PSP) Then
    begin
    R.AH := $49;
    R.ES := EndDos+1;
    MsDos(R);
    end;
  EndDos := EndDos + MemW[EndDos:3] + 1;
  end;
End;

(************************************************)
{    Restore interrupts when terminating TSR     }
(************************************************)

Function TSRExit : Boolean;
Var
  p,q,r,s,t : Pointer;

Begin
GetIntVec(TimerInt,p);
GetIntVec(KbdInt,q);
GetIntVec(Int28Int,r);

If (p = @Clock) AND (q = @KeyBoard) AND (r = @New28) Then
  begin
  SetIntVec(TimerInt,TimerVec);
  SetIntVec(KbdInt,KbdVec);
  SetIntVec(Int28Int,Old28Vec);
  t := nil;
  SetIntVec(TSR_VEC,t);

  rel_mem;

  TSRExit := TRUE;
  end
Else
  begin
  TSRExit := FALSE;
  TSROFF := TRUE;
  end;
End;

(************************************************)

Procedure PopSetup(pr:Pointer;
                   SC,KM : Byte);
Var
  R : Registers;
  adr : Word;
  i : Integer;

Begin
ScanCode := SC;
KeyMask := KM;
PopRtn := pr;
CheckBreak := FALSE;

OurStackSeg := SSeg;

InLine($89/$26/OurStackSP);

R.AH := $34;
MsDos(R);
DosSeg := R.ES;
DOSBusy := R.BX;

R.AH :=$2F;
MsDos(R);
OurDtaSeg := R.ES;
OurDtaOfs := R.BX;

R.AH := $51;
MsDos(R);
TSR_PSP := R.BX;

R.AH := $52;
MsDos(R);
EndDos :=MemW[R.ES:R.BX-2];

PSP_counter := 0;
adr := 0;
While (PSP_counter < 2) and
      (((DosSeg shl 4) + adr) < (EndDos shl 4)) Do
  begin
  If MemW[DosSeg:adr] = TSR_PSP Then
    begin
    R.AH := $50;
    R.BX := TSR_PSP + 1;
    MsDos(R);
    If MemW[DosSeg:adr] = TSR_PSP + 1 Then
      PSP_counter := PSP_counter +1;
    PSPArray[PSP_counter] := adr;
    R.AH := $50;
    R.BX := TSR_PSP;
    msdos(R);
    end;
  adr := adr + 1;
  end;

GetIntVec(TimerInt, TimerVec);

GetIntVec(KbdInt, KbdVec);

GetIntVec(Int28Int, Old28Vec);
End;

(************************************************)

Procedure ResidentPSP;
Var
  i : Byte;
Begin
INT_PSP := PSPArray[1];
For i := 1 To PSP_counter Do
  Memw[DosSeg:PSPArray[i]] := tsr_psp;
End;

(************************************************)

Procedure RestorePSP;
Var
  i : Byte;
Begin
For i := 1 To PSP_counter Do
  MemW[DosSeg:PSPArray[i]] := int_psp;
End;

(************************************************)
{ Replace DTA with the TSR's and                 }
{ install the TSR's critical error interrupt     }
(************************************************)

Procedure BeginPop;
Var
  R : Registers;
Begin
Running := TRUE;

R.AH := $2F;
MsDos(R);
OldDtaSeg := R.ES;
OldDtaOfs := R.BX;
R.AH := $1A;
R.DS := OurDtaSeg;
R.DX := OurDtaOfs;
MsDos(R);

R.AX := $3300;
MsDos(R);
SaveBreak := R.DL;

R.AX := $3301;
R.DL := 0;
MsDos(R);

GetIntVec(CritInt, OldCritVec);
SetIntVec(CritInt, @NewCrit);

ResidentPsp;
End;

(************************************************)

Procedure EndPop;
Var
  R : Registers;
Begin
Running := FALSE;

R.AH := $1A;

R.DS := OldDtaSeg;
R.DX := OldDtaOfs;

MsDos(R);

R.AX := $3301;
R.DL := SaveBreak;
MsDos(R);

SetIntVec(CritInt, OldCritVec);

RestorePSP;
End;

(************************************************)

Function DupCheck(Var S : String; rtn : Pointer) : Byte;
Var
  vec : Word;
  Dif : Word;
  Ptr : Pointer;
  PtrArr : Array[1..2] of Integer Absolute ptr;
  RtnArr : Array[1..2] of Integer Absolute rtn;
  i : Byte;
  st : String;

Begin
dif := Dseg - rtnarr[2];

For Vec := $60 To $67 Do
  begin
  GetIntVec(Vec, ptr);
  If ptr = NIL Then
    begin
    SetIntVec(vec,rtn);
    TSR_VEC := vec;
    DupCheck := 0;
    Exit;
    end;
  Move(Mem[PtrArr[2]+Dif:Ofs(s)],st,Length(s)+1);

  If st = s Then
    begin
    DupCheck := vec;
    Exit;
    end;
  end;
End;

(************************************************)

End.